unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ShellAPI, registry, ComCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Exit1: TMenuItem;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ProgressBar1: TProgressBar;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Label1: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    MATAPT1: TMenuItem;
    GerberXGerber1: TMenuItem;
    PCBAPT1: TMenuItem;
    Help1: TMenuItem;
    Help2: TMenuItem;
    DRCPCB1: TMenuItem;
    PCB1: TMenuItem;
    Button1: TButton;
    procedure Open1Click(Sender: TObject);
    procedure eXit1Click(Sender: TObject);
    procedure ReadRegistry(Sender: TObject);
    procedure SaveRegistry(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MATAPT1Click(Sender: TObject);
    procedure GerberXGerber1Click(Sender: TObject);
    procedure PCBAPT1Click(Sender: TObject);
    procedure Help2Click(Sender: TObject);
    procedure DRCPCB1Click(Sender: TObject);
    procedure PCB1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    f2v1: Integer;
    f2v2: Integer;
    f2v3: Integer;
    f2v4: Integer;
    { Public declarations }
  end;
const
sort_size = 4096;

var
  Form1: TForm1;
  infile, outfile               :TEXT;

  lastpup,donenow,
  rel,absl,pup,pdn              :boolean;

  sline_cnt, linecnt,
  bdminx,bdminy,bdmaxx,bdmaxy,
  pin1x, pin1y,
  ccentx,ccenty,
  arcx,arcy,
  spin1x, spin1y,
  sccentx, sccenty,
  sarcx, sarcy,
  minx,miny,maxx,maxy,
  x,y,lastx,lasty               :longint;

  fill_array                    :array [0..512] of array[0..5] of longint;
  sort_array                    :array [0..sort_size] of string;
  sortnum_array                 :array [0..sort_size] of integer;

  ofilename,
  linestr,
  inbuf,tempstr,
  tempstrx,
  tempstry,
  tempstrx1,
  tempstry1,
  tempstrx2,
  tempstry2,
  tempstrw,
  tempstrl,
  curlinestr                    :string;

  inchar                        :char;

  linemode,
  numfils,
  thisline,
  lastline,
  xi,xa                        :integer;

  WindDir : Array[0..Max_Path] of Char;
  function is_sep(Locc:char):Boolean ;forward;
  function is_num(Locc:char):Boolean ;forward;

  const
   REGNAME = '\Software\Cadcentric';

implementation

uses Unit2, Unit3, Unit4, Unit5, Unit6;

{$R *.DFM}

{---------------------------------------------------------------------------}

function FileExists(FileName: string): Boolean;

{ Boolean function that returns True if the file exists; otherwise,
  it returns False. Closes the file if it exists. }
 var
  F: file;
begin
  {$I-}
  AssignFile(F, FileName);
  FileMode := 0;  //Set file access to read only
  Reset(F);
  CloseFile(F);
  {$I+}
  FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }



{---------------------------------------------------------------------------}
function get_d_code(locs:string):integer;
var
codex,
locx     :integer;
tempstr  :string;
begin
   get_d_code:=-1;                       {assume bad line}
   locx:=1;
   tempstr:='';
   while((locx<length(locs))AND(locs[locx]<>':')) do locx:=locx+1;
   if (locx<length(locs)) then
   begin
      while( (locx<length(locs)) AND(locs[locx]<>'D')) do locx:=locx+1;
      if(locs[locx]='D') then
         begin
            locx:=locx+1;
            while((locx<length(locs))AND (is_sep(locs[locx])=False) ) do
                begin
                   tempstr:=tempstr+locs[locx];
                   locx:=locx+1;
                end;
         end;
   end;
   if (locx<length(locs)) then
      begin
         val(tempstr,locx,codex);
         get_d_code:=locx;
      end;
end;
{---------------------------------------------------------------------------}
function snapto(input_val, snapsize:longint):longint;
begin
   if ((input_val mod snapsize) > (snapsize div 2)) then
        snapto:=(((input_val div snapsize)+1) * snapsize)
   else snapto:=(((input_val div snapsize)) * snapsize);
end;
{---------------------------------------------------------------------------}

{reads co-ords from input line and places them}
{in variable Locxs, Locys}


procedure makexys(LocInbuf:String;Var Locxs1,Locys1,Locxs2,Locys2,Locsw,Locsl:String);
var
locdebug,
locx    :Integer;
begin
   locdebug:=0;
   Locxs1:='';
   Locys1:='';
   Locxs2:='';
   Locys2:='';
   Locsl:='';
   Locsw:='';
   Locx:=1;
{get x1}
   while Locinbuf[Locx]<>' ' do
   begin
      Locxs1:=Locxs1+Locinbuf[Locx];
      Locx:=Locx+1;
   end;

   Locx:=Locx+1;

{get y1}
   while Locinbuf[Locx]<>' ' do
   begin
      Locys1:=Locys1+Locinbuf[Locx];
      Locx:=Locx+1;
   end;

   Locx:=Locx+1;

{get x2}
   while Locinbuf[Locx]<>' ' do
   begin
      Locxs2:=Locxs2+Locinbuf[Locx];
      Locx:=Locx+1;
   end;
if locdebug=1 then writeln;
if locdebug=1 then writeln(locInBuf);
if locdebug=1 then write(locxs1,'-');
if locdebug=1 then write(locys1,'-');
if locdebug=1 then write(locxs2,'-');

   Locx:=Locx+1;

{get y2}
   while Locinbuf[Locx]<>' ' do
   begin
      Locys2:=Locys2+Locinbuf[Locx];
      Locx:=Locx+1;
   end;

   Locx:=Locx+1;

{get w and ignore}
   while ((Locinbuf[Locx]<>' ')) do
   begin
      Locsw:=Locsw+LocInbuf[LocX];
      LocX:=LocX+1;
   end;

   Locx:=Locx+1;

{get l}
   while ((Locinbuf[Locx]<>' ')) do
   begin
      Locsl:=Locsl+LocInbuf[LocX];
      LocX:=LocX+1;
   end;

if locdebug=1 then writeln;
if locdebug=1 then writeln(locInBuf);
if locdebug=1 then write(locxs1,'-');
if locdebug=1 then write(locys1,'-');
if locdebug=1 then write(locxs2,'-');
if locdebug=1 then write(locys2,'-');
if locdebug=1 then writeln(locsw,'-');
if locdebug=1 then writeln(locsl,'-');

end;

{---------------------------------------------------------------------------}

{reads co-ords from input line and places them}
{in variable Locxs, Locys}


procedure minmax(Locxs1,Locys1,Locxs2,Locys2:String);
var
localdebug,
codex  :Integer;
locx1,
locy1,
locx2,
locy2   :longint;
begin
   localdebug:=0;
   val(Locxs1,locx1,Codex);
   val(Locys1,locy1,Codex);
   val(Locxs2,locx2,Codex);
   val(Locys2,locy2,Codex);

   if minx>locx1 then minx:=locx1;
   if minx>locx2 then minx:=locx2;

   if miny>locy1 then Miny:=locy1;
   if miny>locy2 then Miny:=locy2;

   if maxx<locx1 then maxx:=locx1;
   if maxx<locx2 then maxx:=locx2;

   if maxy<locy1 then maxy:=locy1;
   if maxy<locy2 then maxy:=locy2;

if localdebug=1 then write('*');
end;

{---------------------------------------------------------------------------}
procedure pad_loc(Locs:string);
var
   Locxs1,
   Locys1,
   Locxs2,
   Locys2       :string;
   localdebug,
   locx         :Integer;

begin
   localdebug:=0;
   Locxs1:='';
   Locys1:='';
   Locx:=1;
if localdebug=1 then writeln;
if localdebug=1 then writeln(locs);
{get x1}
   while Locs[Locx]<>' ' do
   begin
      Locxs1:=Locxs1+Locs[Locx];
      Locx:=Locx+1;
   end;

   Locx:=Locx+1;
if localdebug=1 then write(locxs1,'-');

{get y1}
   while Locs[Locx]<>' ' do
   begin
      Locys1:=Locys1+Locs[Locx];
      Locx:=Locx+1;
   end;
if localdebug=1 then write(locys1,'-');
   Locxs2:=locxs1;
   Locys2:=locys1;
   minmax(locxs1,locys1,locxs2,locys2);

   readln(infile,Locys2);{read the pin number}
   if (Locys2='1') then
   begin
      val(Locxs1,pin1x,locx);
      val(Locys1,pin1y,locx);
   end;
end;
{---------------------------------------------------------------------------}
procedure arc_loc(Locs:string);
var
   Locxs1,
   Locys1,
   Locxs2,
   Locys2       :string;
   localdebug,
   locx         :Integer;

begin
   localdebug:=0;
   Locxs1:='';
   Locys1:='';
   Locx:=1;
{get x1}
   while Locs[Locx]<>' ' do
   begin
      Locxs1:=Locxs1+Locs[Locx];
      Locx:=Locx+1;
   end;

   Locx:=Locx+1;

{get y1}
   while Locs[Locx]<>' ' do
   begin
      Locys1:=Locys1+Locs[Locx];
      Locx:=Locx+1;
   end;
   Locxs2:=locxs1;
   Locys2:=locys1;

   begin
      val(Locxs1,arcx,locx);
      val(Locys1,arcy,locx);
   end;
if localdebug=1 then writeln;
if localdebug=1 then writeln(locs);
if localdebug=1 then write(locxs1,'-');
if localdebug=1 then write(locys1,'-');
end;
{---------------------------------------------------------------------------}
function fill_loc(Locs:string):Integer;
var
locx,
codex           :Integer;
begin
   makexys(Locs,tempstrx1,tempstry1,tempstrx2,tempstry2,tempstrw,tempstrl);
   val(tempstrw,locX,Codex);
   fill_loc:=LocX;
   if ((LocX=1) OR (LocX=6))then
      minmax (tempstrx1,tempstry1,tempstrx2,tempstry2);
end;
{---------------------------------------------------------------------------}
function is_sep(Locc:char):Boolean;
begin
   is_sep:=False;
   if(locc=' ') then is_sep:=True;
   if(locc=chr(9)) then is_sep:=True;
   if(locc=',') then is_sep:=True;
   if(locc=')') then is_sep:=True;

end;
{---------------------------------------------------------------------------}
function is_num(Locc:char):Boolean;
begin
   is_num:=False;
   if((LocC>='0')AND(LocC<='9')) then is_num:=True;
end;
{---------------------------------------------------------------------------}
function comp_sort(LocI:Integer):Boolean;
var
x  :Integer;
LocS1, LocS2 :String;
begin

   comp_sort:=False; {assume correct order}
   LocS1:='';
   LocS2:='';
   x:=1;
   while (
         (is_sep(sort_array[LocI][x])=False)
         AND
         (is_num(sort_array[LocI][x])=False)
         ) do begin LocS1:=LocS1+sort_array[LocI][x]; x:=x+1; end;

   x:=1;
   while (
         (is_sep(sort_array[LocI+1][x])=False)
         AND
         (is_num(sort_array[LocI+1][x])=False)
         ) do begin LocS2:=LocS2+sort_array[LocI+1][x]; x:=x+1; end;

   if (LocS1<LocS2) then comp_sort:=False
   else if (LocS1>LocS2) then comp_sort:=True
   else if ((LocS1=LocS2) AND( sortnum_array[LocI]>sortnum_array[LocI+1]))
            then comp_sort:=True;
end;
{---------------------------------------------------------------------------}

procedure arrayadd(Locxs1,Locys1,Locxs2,Locys2:String);
var
localdebug,
codex   :Integer;
locx1,
locy1,
locx2,
locy2   :longint;
begin
   localdebug:=0;
   val(Locxs1,locx1,Codex);
   val(Locys1,locy1,Codex);
   val(Locxs2,locx2,Codex);
   val(Locys2,locy2,Codex);

   if locx2>locx1 then fill_array[numfils][0]:=locx1;
   if locx1>locx2 then fill_array[numfils][0]:=locx2;
   if locy2>locy1 then fill_array[numfils][1]:=locy1;
   if locy2>locy2 then fill_array[numfils][1]:=locy2;
   if locx2< locx1 then fill_array[numfils][4]:=locx1-locx2;
   if locx2>=locx1 then fill_array[numfils][4]:=locx2-locx1;
   if locy2< locy1 then fill_array[numfils][5]:=locy1-locy2;
   if locy2>=locy1 then fill_array[numfils][5]:=locy2-locy1;
   fill_array[numfils][2]:=snapto(fill_array[numfils][4],5);
   fill_array[numfils][3]:=snapto(fill_array[numfils][5],5);

if localdebug=1 then write('*');
end;


{---------------------------------------------------------------------------}
procedure get_comp_loc;
var
layer  :char;
x, bigxcnt,smallxcnt,
bigycnt,smallycnt,
snapgrid,
rotation,
numpads,
ilayer   :Integer;
seperator :char;
fillx,
filly   :Longint;

begin
   layer:='T';
   minx:=100000;
   miny:=100000;
   maxx:=-100000;
   maxy:=-100000;
   pin1x:=-1;
   pin1y:=-1;
   arcx:=-1;
   arcy:=-1;
   snapgrid:=25;
   rotation:=-1;
   numpads:=0;
   numfils:=0;
   if form1.checkbox2.checked=True then seperator:=',' else seperator:=chr(9);

   readln(infile,inbuf); {get component designator}
//   write(outfile,inbuf,seperator);
   curlinestr:=inbuf+seperator;
   inbuf:='';
   while ((inbuf<>'ENDCOMP') AND(EOF(InFile)=False)) do
   begin
        readln(infile,inbuf);
        if (inbuf='CP') then
        begin
           readln(infile,inbuf);
           pad_loc(inbuf);
           numpads:=numpads+1;
        end

        else if (inbuf='CA') then
        begin
           readln(infile,inbuf);
           arc_loc(inbuf);
           makexys(inbuf+' 1 1 1',tempstrx1,tempstry1,tempstrx2,tempstry2,tempstrw,tempstrl);
           val(tempstrl,ilayer,x);
           if (ilayer=(Form1.combobox2.itemindex)) then layer:='B';
           if (ilayer=(Form1.combobox1.itemindex)) then layer:='T';
        end

        else if (inbuf='CF') then
        begin
           readln(infile,inbuf);
           ilayer:=fill_loc((inbuf+' 1 1'));
           if (ilayer=(Form1.combobox2.itemindex)) then layer:='B';
           if (ilayer=(Form1.combobox4.itemindex)) then layer:='B';
           if (ilayer=(Form1.combobox1.itemindex)) then layer:='T';
           if (ilayer=(Form1.combobox3.itemindex)) then layer:='T';
           if ((ilayer=(Form1.combobox4.itemindex)) or (ilayer=(Form1.combobox3.itemindex))) then
           begin
              arrayadd(tempstrx1,tempstry1,tempstrx2,tempstry2);
              numfils:=numfils+1;
           end;
        end
        else if (inbuf='CT') then
        begin
           readln(infile,inbuf);
           makexys(inbuf,tempstrx1,tempstry1,tempstrx2,tempstry2,tempstrw,tempstrl);
           val(tempstrl,ilayer,x);
           if (ilayer=(Form1.combobox2.itemindex)) then layer:='B';
           if (ilayer=(Form1.combobox1.itemindex)) then layer:='T';
        end;

   end;

{start of remove robber pads}
   if ((numpads=0) AND (numfils>8)AND (Form1.CheckBox1.checked=True)) then
   begin
{test for robber pads, remove and recompute if present}
      Fillx:=fill_array[0][2];
      Filly:=fill_array[0][3];
      bigxcnt:=0;
      smallxcnt:=0;
      bigycnt:=0;
      smallycnt:=0;
      for x:=0 to (numfils-1) do
      begin
         if (fill_array[x][2]>fillx) then bigxcnt:=bigxcnt+1;
         if (fill_array[x][2]<fillx) then smallxcnt:=smallxcnt+1;
         if (fill_array[x][3]>filly) then bigycnt:=bigycnt+1;
         if (fill_array[x][3]<filly) then smallycnt:=smallycnt+1;
      end;

      if (bigxcnt=2) then
      begin
      for x:=0 to (numfils-1) do
         if (fill_array[x][2]>fillx) then fill_array[x][0]:=-1;
      end

      else if (bigycnt=2) then
      begin
      for x:=0 to (numfils-1) do
         if (fill_array[x][3]>filly) then fill_array[x][0]:=-1;
      end

      else if (smallxcnt=(numfils-2)) then
      begin
      for x:=0 to (numfils-1) do
         if (fill_array[x][2]=fillx) then fill_array[x][0]:=-1;
      end

      else if (smallycnt=(numfils-2)) then
      begin
      for x:=0 to (numfils-1) do
         if (fill_array[x][3]=filly) then fill_array[x][0]:=-1;
      end;

      if (
         (bigxcnt=2) OR
         (bigycnt=2) OR
         (smallxcnt=(numfils-2)) OR
         (smallycnt=(numfils-2))
         ) then
      begin
         minx:=100000;
         maxx:=-1;
         miny:=100000;
         maxy:=-1;
{         writeln('****');}
         for x:=0 to (numfils-1) do
         begin
{            writeln(fill_array[x][0],' ',fill_array[x][1],' ',fill_array[x][2],' ',fill_array[x][3]);}
            if (fill_array[x][0]>0) then
            begin
               if (fill_array[x][0]<minx) then minx:=fill_array[x][0];
               if (fill_array[x][1]<miny) then miny:=fill_array[x][1];
                if ((fill_array[x][0]+fill_array[x][4])>maxx) then
                  maxx:=(fill_array[x][0]+fill_array[x][4]);
               if ((fill_array[x][1]+fill_array[x][5])>maxy) then
                  maxy:=(fill_array[x][1]+fill_array[x][5]);
            end;
         end;
      end;
   end;
{end of remove robber pads}

   ccentx:=(minx+((maxx-minx)div 2));
   ccenty:=(miny+((maxy-miny) div 2));
{mirror bottom side x axis}
   if (layer='B') then ccentx:=bdmaxx-ccentx;
   if ((layer='B') AND (pin1x> 0)) then pin1x:=bdmaxx-pin1x;
   if ((layer='B') AND (arcx > 0)) then arcx:=bdmaxx-arcx;
{make snapto vairables}
   spin1x:=snapto(pin1x,snapgrid);
   spin1y:=snapto(pin1y,snapgrid);
   sarcx:=snapto(arcx,snapgrid);
   sarcy:=snapto(arcy,snapgrid);
   sccentx:=snapto(ccentx,snapgrid);
   sccenty:=snapto(ccenty,snapgrid);

{compute rotation}
   if (pin1x > 0) then
   begin
     {snap to here}
     if ((pin1x<ccentx) AND (spin1y=sccenty)) then rotation:=0
     else if ((pin1x>ccentx) AND (spin1y=sccenty)) then rotation:=180
     else if ((spin1x=sccentx) AND (pin1y>ccenty)) then rotation:=90
     else if ((spin1x=sccentx) AND (pin1y<ccenty)) then rotation:=270
     else if ((pin1x<ccentx) AND (pin1y<ccenty)) then rotation:=0
     else if ((pin1x<ccentx) AND (pin1y>ccenty)) then rotation:=90
     else if ((pin1x>ccentx) AND (pin1y>ccenty)) then rotation:=180
     else if ((pin1x>ccentx) AND (pin1y<ccenty)) then rotation:=270;
   end

   else if ((arcx>0)AND((sarcx<>sccentx)OR(sarcy<>sccenty))) then
   begin
     if ((arcx<ccentx) AND (sarcy=sccenty)) then rotation:=0
     else if ((arcx>ccentx) AND (sarcy=sccenty)) then rotation:=180
     else if ((sarcx=sccentx) AND (arcy>ccenty)) then rotation:=90
     else if ((sarcx=sccentx) AND (arcy<ccenty)) then rotation:=270
     else if ((arcx<ccentx) AND (arcy<ccenty)) then rotation:=0
     else if ((arcx<ccentx) AND (arcy>ccenty)) then rotation:=90
     else if ((arcx>ccentx) AND (arcy>ccenty)) then rotation:=180
     else if ((arcx>ccentx) AND (arcy<ccenty)) then rotation:=270;
   end

   else if ((maxx-minx)>(maxy-miny)) then rotation:=0
   else if ((maxx-minx)<(maxy-miny)) then rotation:=90;
{end compute rotation}

//   write(outfile,(ccentx/1000):4:3,seperator,(ccenty/1000):4:3,seperator);
     curlinestr:=curlinestr+FloatTostrF((ccentx/1000),fffixed,4,3)+seperator;
     curlinestr:=curlinestr+floattostrF((ccenty/1000),fffixed,4,3)+seperator;

   {layer and rotation}
   curlinestr:=curlinestr+layer+seperator;
   if (rotation > -1) then curlinestr:=curlinestr+IntToStr(rotation)
   else curlinestr:=curlinestr+'?';
   sort_array[sline_cnt]:=curlinestr;
   sline_cnt:=sline_cnt+1;
end;

procedure TForm1.Open1Click(Sender: TObject);
var
yi,
max_line :Integer;
changed  :Boolean;
begin

opendialog1.FilterIndex:=1;
if (opendialog1.Execute=true) then
   begin
     ProgressBar1.Visible:=True;
     assignfile(infile,opendialog1.filename);
     Label2.caption:='pass 1.  Computing board size.';
     label2.Repaint;
     linecnt:=0;
     sline_cnt:=0;
     RESET(INFILE);
     inbuf:=opendialog1.filename;
     Tempstr:='';
     xi:=1;
     while inbuf[xi]<>'.' do
     begin
        TempStr:=TempStr+inbuf[xi];
        xi:=xi+1;
     end;
     TempStr:=TempStr+'.UCM';
     ofilename:=TempStr;     {save output file name}

     assignfile(outfile,TempStr);
     rewrite(outfile);
     rel:=False;
     absl:=TRUE;
     lastx:=0;
     lasty:=0;
     pup:=True;
     DoneNow:=False;
     lastpup:=pup;
     minx:=100000;
     miny:=100000;
     maxx:=-100000;
     maxy:=-100000;
     linemode:=0;
     ProgressBar1.Position:=0;
{search for all FT (free tracks) on layer 7 and 11 (overlay and board)
 to get the min and max board size}


     while (not eof(infile) and (NOT DoneNow)) do
     begin
     repeat
     readln(infile,inbuf);
     until (inbuf<>'');
     if linemode=1 then
     begin
        makexys(inbuf,tempstrx1,tempstry1,tempstrx2,tempstry2,tempstrw,tempstrl);
        if ((tempstrl='7') OR (tempstrl='11')) then
        minmax (tempstrx1,tempstry1,tempstrx2,tempstry2);
     end;
     if length(inbuf)>=2 then
     begin
        linestr:=inbuf[1];
        linestr:=linestr+inbuf[2];
        linemode:=0;
        if linestr='FT' then linemode:=1;   {1=pa}
     end;
     linecnt:=linecnt+1;
     if ((linecnt MOD 250)=0)then begin
                                 ProgressBar1.Position:=ProgressBar1.Position+1;
                                 if (ProgressBar1.Position=100) then
                                          ProgressBar1.Position:=0;
                                 ProgressBar1.Repaint;
                                 end;
     end;{while not end of infile}

     RESET(INFILE);
     bdminx:=minx;
     bdminy:=miny;
     bdmaxx:=maxx;
     bdmaxy:=maxy;
     label3.caption:='x = '+floattostrf((maxx/1000),fffixed,4,3);
     label4.caption:='y = '+floattostrf((maxy/1000),fffixed,4,3);
     writeln(outfile,'corners at ',(minx/1000):4:3,', ',(miny/1000):4:3,' x ',(maxx/1000):4:3,', ',(maxy/1000):4:3);
     minx:=100000;
     miny:=100000;
     maxx:=-100000;
     maxy:=-100000;
     linecnt:=0;
     ProgressBar1.Position:=0;
     {------------------------------------------------------------------------}

     label2.caption:='pass 2.  Computing component centers.';
     label2.Repaint;
     writeln(outfile,'Component ID, x position, y position, Side, Rotation');

     while (not eof(infile) and (NOT DoneNow)) do
     begin
     repeat
     readln(infile,inbuf);
     until (inbuf<>'');
     linestr:=inbuf[1];
     linestr:=linestr+inbuf[2];
     linestr:=linestr+inbuf[3];
     linestr:=linestr+inbuf[4];
     if linestr='COMP' then get_comp_loc;

     linecnt:=linecnt+1;
     if ((linecnt MOD 250)=0)then begin
                                 ProgressBar1.Position:=ProgressBar1.Position+1;
                                 if (ProgressBar1.Position=100) then
                                          ProgressBar1.Position:=0;
                                 ProgressBar1.Repaint;
                                 end;

     end;{while not end of infile}
     max_line:=sline_cnt-1;
     yi:=max_line;
     if (checkbox4.checked)=True then
     begin
//       sort
//       build list of component ids
     label2.caption:='Sorting.                          ';
     Form1.repaint;
     x:=0;
     while (x<(yi+1)) do
     begin
        y:=1;
        while (
               (is_sep(sort_array[x][y])=False) AND
               (is_num(sort_array[x][y])=False)
               ) do y:=y+1;
        if (is_num(sort_array[x][y])=true) then
        begin
        curlinestr:='';
        while (is_num(sort_array[x][y])=True) do
            begin
               curlinestr:=curlinestr+sort_array[x][y];
               y:=y+1;
            end;
        val(curlinestr,sortnum_array[x],xi)
        end
        else sortnum_array[x]:=-1;
     x:=x+1;
     end;{while x}

     repeat
        begin
           Changed:=False;
           y:=0;
           while (y<yi) do         begin xi:=y+1;
                                         if (comp_sort(y) = True) then
                                           begin
                                              curlinestr:=sort_array[y];
                                              sort_array[y]:=sort_array[xi];
                                              sort_array[xi]:=curlinestr;
                                              x:=sortnum_array[xi];
                                              sortnum_array[xi]:=sortnum_array[y];
                                              sortnum_array[y]:=x;
                                              changed:=True;
                                           end;
                                     y:=y+1;
                                     end;{while y}
                                 ProgressBar1.Position:=ProgressBar1.Position+1;
                                 if (ProgressBar1.Position=100) then
                                          ProgressBar1.Position:=0;
                                 ProgressBar1.Repaint;


        end;{of repeat}
     until (Changed=False);

     end;
 //write output file
      max_line:=sline_cnt;
      x:=0;
      while (x<max_line) do begin
                               writeln(outfile,sort_array[x]);
                               x:=x+1;
                            end;

     closefile(infile);
     closefile(outfile);
     label2.caption:='Ready';
     label2.Repaint;
     ProgressBar1.visible:=false;
     GetWindowsDirectory(WindDir, Max_Path);
     inbuf := StrPas(WindDir)+'\NOTEPAD.EXE';
     If (Form1.Checkbox3.checked=True) then
       ShellExecute(Handle,'open',
       Pchar(inbuf),Pchar(ofilename),
       nil, SW_SHOWNORMAL);
   end;
end;

{---------------------------------------------------------------------------}

procedure TForm1.eXit1Click(Sender: TObject);
begin
Form1.close;
end;

{---------------------------------------------------------------------------}

procedure TForm1.ReadRegistry(Sender: TObject);
var
   Registry: TRegistry;
begin
   Registry:= TRegistry.Create;
   with Registry do begin
      if (OpenKey( REGNAME, False )=False) then
       begin
          OpenKey( REGNAME, True );
          WriteString('DIRECTORY',opendialog1.InitialDir);
          WriteInteger('TopLeg',7);
          WriteInteger('BotLeg',3);
          WriteInteger('TopFill',1);
          WriteInteger('BotFill',6);
          WriteInteger('Digits',2);
          WriteInteger('Precision',4);
          WriteInteger('Mode',0);
          WriteInteger('Suppression',0);
       end ;
       begin
          opendialog1.InitialDir:=ReadString('DIRECTORY');
          combobox1.itemindex:=ReadInteger('TopLeg');
          combobox2.itemindex:=ReadInteger('BotLeg');
          combobox3.itemindex:=ReadInteger('TopFill');
          combobox4.itemindex:=ReadInteger('BotFill');
          f2v1:=ReadInteger('Digits');
          f2v2:=ReadInteger('Precision');
          f2v3:=ReadInteger('Mode');
          f2v4:=ReadInteger('Suppression');

       end ;
      CloseKey;
   end;
   Registry.Free;
end;

{---------------------------------------------------------------------------}

procedure TForm1.SaveRegistry(Sender: TObject);
var
   Registry: TRegistry;
   ipath,iipath:string;
   x, y: integer;
begin
//   if opendialog1.filename<>'' then
   begin
   ipath:=opendialog1.filename;
   iipath:='';
   x:=length(ipath);
   while ((x>0) AND (ipath[x]<>'\')) do x:=x-1;
   for y:=1 to x do iipath:=iipath+ipath[y];
   Registry := TRegistry.Create;
   with Registry do begin
      if OpenKey( REGNAME, True ) then
       begin
          WriteString('DIRECTORY',iipath);
          WriteInteger('TopLeg',combobox1.itemindex);
          WriteInteger('BotLeg',combobox2.itemindex);
          WriteInteger('TopFill',combobox3.itemindex);
          WriteInteger('BotFill',combobox4.itemindex);
          WriteInteger('Digits',f2v1);
          WriteInteger('Precision',f2v2);
          WriteInteger('Mode',f2v3);
          WriteInteger('Suppression',f2v4);
          CloseKey;
       end;
   end;
   Registry.Free;
   end;
end;
{---------------------------------------------------------------------------}

procedure TForm1.FormCreate(Sender: TObject);
begin
ReadRegistry(self);
end;
{---------------------------------------------------------------------------}

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
SaveRegistry(self);
end;
{---------------------------------------------------------------------------}

procedure TForm1.MATAPT1Click(Sender: TObject);
var
changed,
continue    :boolean;
yi,d_code   :Integer;
begin
opendialog1.FilterIndex:=3;
if (opendialog1.Execute=true) then
   begin
     ProgressBar1.Visible:=False;
     continue:=True;
     assignfile(infile,opendialog1.filename);
     Label2.caption:='pass 1.  Reading MAT file.';
     Form1.Repaint;
     linecnt:=0;
     sline_cnt:=0;
     RESET(INFILE);
     inbuf:=opendialog1.filename;
     Tempstr:='';
     xi:=1;
     while inbuf[xi]<>'.' do
     begin
        TempStr:=TempStr+inbuf[xi];
        xi:=xi+1;
     end;
     TempStr:=TempStr+'.APT';
     ofilename:=TempStr;     {save output file name}
     If (FileExists(ofilename)=True) then
        begin
        inbuf:='File '+ofilename+' exisits!  Replace this file?';
        if MessageDlg(inbuf, mtConfirmation,[mbYes, mbNo], 0) = mrNo then Continue:=False;
        end;
     if (continue=True) then
     begin

     assignfile(outfile,TempStr);
     rewrite(outfile);
     ProgressBar1.Position:=0;
     ProgressBar1.Visible:=True;
{find all DCODE lines}

     while (not eof(infile)) do
     begin
        repeat
           readln(infile,inbuf);
        until ((inbuf<>'')OR (EOF(infile)));
        d_code:=get_d_code(inbuf);
         if (d_code>0) then
            begin
                x:=0;
                while( (x<linecnt)AND(sortnum_array[x]<>d_code)) do x:=x+1;
                if (x=linecnt) then
                begin
                   sortnum_array[linecnt]:=d_code;
                   sort_array[linecnt]:=inbuf;
                   linecnt:=linecnt+1;
                   sortnum_array[linecnt]:=-1;
                   ProgressBar1.Position:=ProgressBar1.Position+1;
                   if (ProgressBar1.Position=100) then
                   ProgressBar1.Position:=0;
                   ProgressBar1.Repaint;
                end;
            end;
     end;{while not end of infile}
     repeat
        begin
           Changed:=False;
           x:=0;
           while (x<(linecnt-1)) do
                    begin
                       if (sortnum_array[x]>sortnum_array[x+1]) then
                           begin
                              curlinestr:=sort_array[x];
                              sort_array[x]:=sort_array[x+1];
                              sort_array[x+1]:=curlinestr;
                              y:=sortnum_array[x];
                              sortnum_array[x]:=sortnum_array[x+1];
                              sortnum_array[x+1]:=y;
                              changed:=True;
                           end;
                       x:=x+1;
                       end;{while x}
                       ProgressBar1.Position:=ProgressBar1.Position+1;
                       if (ProgressBar1.Position=100) then
                           ProgressBar1.Position:=0;
                       ProgressBar1.Repaint;
        end;{of repeat}
     until (Changed=False);

      x:=0;
      while (x<linecnt) do
         begin
            y:=0;
            tempstr:=sort_array[x];
            inbuf:='';
            while (tempstr[y]<>'D') do y:=y+1;
            yi:=y;
            while (y<=(length(tempstr))) do  begin inbuf:=inbuf+tempstr[y]; y:=y+1; end;
            inbuf:=inbuf+chr(9);
            y:=1;
            while (y<(yi-2)) do begin inbuf:=inbuf+tempstr[y]; y:=y+1; end;
            writeln(outfile,inbuf);
            x:=x+1;
         end;

     label2.caption:='Ready';
     ProgressBar1.visible:=false;
     Form1.Repaint;

     closefile(infile);
     closefile(outfile);

     GetWindowsDirectory(WindDir, Max_Path);
     inbuf := StrPas(WindDir)+'\NOTEPAD.EXE';
     If (Form1.Checkbox3.checked=True) then
       ShellExecute(Handle,'open',
       Pchar(inbuf),Pchar(ofilename),
       nil, SW_SHOWNORMAL);

   end;{if continue = true}
   end; {if opendialog=mrok}

end;

procedure TForm1.GerberXGerber1Click(Sender: TObject);
begin
Form2.showmodal;
f2v1:=Form2.spinedit1.value;
f2v2:=Form2.spinedit2.value;
f2v3:=Form2.Radiogroup1.ItemIndex;
f2v4:=Form2.Radiogroup2.itemIndex;
end;


procedure TForm1.PCBAPT1Click(Sender: TObject);
begin
Form3.showmodal;
end;

procedure TForm1.Help2Click(Sender: TObject);
begin
Aboutbox.showmodal;
end;

procedure TForm1.DRCPCB1Click(Sender: TObject);
Begin
Form5.showmodal;
end;

procedure TForm1.PCB1Click(Sender: TObject);
begin
   Form6.ShowModal;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Open1Click(Self);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   Form1.Menu := nil;
end;

end.

