unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls;

type
  TForm2 = class(TForm)
    ComboBox1: TComboBox;
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    SaveDialog1: TSaveDialog;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    RadioGroup3: TRadioGroup;
    Label3: TLabel;
    RadioGroup4: TRadioGroup;
    procedure Edit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Write_Apts;
    procedure Write_one_xgerber;
    procedure Write_multiple_xgerbers;

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
var
ifile,
ofile     :TEXT;
procedure Aptline(line:string; var dcode:integer;
                               var shape :string;
                               var xsize  :integer;
                               var ysize  :integer);

implementation

uses Unit1;

{$R *.DFM}
{-----------------------------------------------------------------------}
procedure Aptline(line:string; var dcode:integer;
                               var shape :string;
                               var xsize  :integer;
                               var ysize  :integer);
var
locy,
locx,
locz  :Integer;
begin
locx:=2; dcode:=0; xsize:=0; ysize:=0; shape:='';
while (is_sep(line[locx])=False) do
   begin
      val(line[locx],locy,locz);
      dcode:=(dcode*10)+locy;
      locx:=Locx+1;
   end;

   while (is_sep(line[locx])=True) do locx:=locx+1;

   while (is_sep(line[locx])=False) do
   begin
      shape:=shape+line[locx];
      locx:=Locx+1;
   end;
   shape:=uppercase(shape);

   while (is_num(line[locx])=False) do locx:=locx+1;

while (is_sep(line[locx])=False) do
   begin
      val(line[locx],locy,locz);
      xsize:=(xsize*10)+locy;
      locx:=Locx+1;
   end;

   while (is_num(line[locx])=False) do locx:=locx+1;

while (is_sep(line[locx])=False) do
   begin
      val(line[locx],locy,locz);
      ysize:=(ysize*10)+locy;
      locx:=Locx+1;
   end;

end;

{-----------------------------------------------------------------------}
//  write aperture list
procedure TForm2.Write_Apts;
var
xs,ys,dc     :Integer;
xss,yss,
xss1,xss2,
tss1,
temps,
inbuf        :AnsiString;
begin
       Assignfile(ifile,ComboBox1.Text);
       RESET(ifile);
       writeln(ofile,'G04 Format statement*');
       write(ofile,'%FS');
       if (RadioGroup2.itemindex=0) then write(ofile,'L')
       else if (RadioGroup2.itemindex=1) then write(ofile,'T')
       else if (RadioGroup2.itemindex=2) then write(ofile,'D');
       if (RadioGroup1.itemindex=0) then write(ofile,'A')
       else if (RadioGroup1.itemindex=1) then write(ofile,'I');
       writeln(ofile,'X',SpinEdit1.Value,SpinEdit2.Value,
                     'Y',SpinEdit1.Value,SpinEdit2.Value,'*%');
       if (RadioGroup4.ItemIndex=0) then writeln(ofile,'%MOIN*%')
       else writeln(ofile,'%MOMM*%');
       writeln(ofile,'G04 Apeture information*');
//process aperture file
       While (Not EOF(ifile)) do
           begin
              readln(ifile,inbuf);

{
              inbuf:=uppercase(inbuf);
              SubStr:='ROUND RECT';
              instr:=@inbuf;
              p:=StrPos(instr,SubStr);
              showmessage(instr);
              if (not(p = nil)) then
              begin
                   showmessage(inbuf);
                 d:=p+1;
                 while(d^ <> null) do
                 begin
                    p^:=d^;
                    p:=p+1;
                    d:=d+1
                 end;
                   showmessage(inbuf);
              end;
}
              aptline(inbuf,dc,temps,xs,ys);
              xss:=IntToStr(xs MOD 1000);
              while (length(xss)<3) do xss:='0'+xss;
              xss1:=IntToStr(xs div 2);
              tss1:=IntToStr(xs+20);
              while (length(xss1)<3) do xss1:='0'+xss1;
              while (length(tss1)<3) do tss1:='0'+tss1;
              xss2:=IntToStr(xs div 4);
              while (length(xss2)<3) do xss2:='0'+xss2;
              yss:=IntToStr(ys MOD 1000);
              while (length(yss)<3) do yss:='0'+yss;

              xss:='.'+xss;
              yss:='.'+yss;
              if(ys>=1000) then yss:=IntToStr(ys div 1000)+yss;
              if(xs>=1000) then xss:=IntToStr(xs div 1000)+xss;

              if temps='CIRCULAR' then
                 writeln(ofile,'%ADD',dc,'C,',xss,'*%');
              if temps='RECTANGULAR' then
                 writeln(ofile,'%ADD',dc,'R,',xss,'X',yss,'*%');
              if temps='ROUNDRECT' then
                 writeln(ofile,'%ADD',dc,'O,',xss,'X',yss,'*%');
              if temps='OCTAGONAL' then
                 writeln(ofile,'%ADD',dc,'P,',xss,'X8*%');
              if temps='RELIEF' then
                 begin
//                 writeln(ofile,'%AMTHERM',xs,'*7,0,0,.',xss,',.',xss1,',.',xss2,',0*%');
                 writeln(ofile,'%AMTHERM',xs,'*7,0,0,.',tss1,',',xss,',.',xss2,',0*%');
                 writeln(ofile,'%ADD',dc,'THERM',xs,'*%');
                 end;
//              writeln(ofile,inbuf);
           end;   {of  while (Not EOF(ifile)) do}
       closefile(ifile);
       writeln(ofile,'G04 End of apeture information*');
end; {of procedue}

{-----------------------------------------------------------------------}

procedure TForm2.Edit1Change(Sender: TObject);
begin
Form1.opendialog1.filterindex:=4;
Form1.opendialog1.filename:='';
if form1.opendialog1.execute=true then
   begin
      combobox1.Items.Add(Form1.opendialog1.filename);
      combobox1.Text:=Form1.opendialog1.filename;
   end;
end;
{-----------------------------------------------------------------------}

procedure TForm2.Button1Click(Sender: TObject);
begin
Form1.opendialog1.options:= [ofAllowMultiSelect];
Form1.opendialog1.filterindex:=2;
Form1.opendialog1.filename:='';
if form1.opendialog1.execute=true then
   begin
      Listbox1.Items.AddStrings(Form1.opendialog1.Files);
   end;

Form1.opendialog1.options:= [];end;
{-----------------------------------------------------------------------}

procedure TForm2.Write_one_xgerber;
var
z,
x,y          :Integer;
xss,
inbuf        :AnsiString;
begin
    Savedialog1.InitialDir:=Form1.Opendialog1.InitialDir;
    Savedialog1.filterindex:=1;
    If (savedialog1.execute=True) then
    begin
    if ((ComboBox1.Text<>'')AND(listbox1.Items.count>=1))  then
    begin
       AssignFile(ofile,savedialog1.filename);
       Rewrite(ofile);
       Write_Apts();
       x:=0;
       While(x<listbox1.items.count) do
          begin
          Assignfile(ifile,listbox1.items[x]);
          RESET(ifile);
          writeln(ofile,'G04 data from ',listbox1.items[x],'*');
          inbuf:=listbox1.items[x];
          y:=length(inbuf);
          while ((inbuf[y]<>'\')AND(y>0)) do y:=y-1;
          xss:='';
          if(y>1) then y:=y+1;
          while (y<=length(inbuf)) do begin xss:=xss+ upcase(inbuf[y]); y:=y+1; end;
          writeln(ofile,'%IN',xss,'*%');
          While (Not EOF(ifile)) do
              begin
                 readln(ifile,inbuf);
                 z:=1;
                 while(z<length(inbuf)) do
                 begin
                   if ((inbuf[z]='M')AND(inbuf[z+1]='0')AND(inbuf[z+2]='2'))
                    then begin
                       inbuf[z]:=' ';
                       inbuf[z+1]:=' ';
                       inbuf[z+2]:=' ';
                       inbuf[z+3]:=' ';
                       end;
                 z:=z+1;
                 end;
                 if (inbuf[1]<>chr(8)) then writeln(ofile,inbuf);
              end;
          closefile(ifile);
          x:=x+1;
          end;

       writeln(ofile,'M02*');
       closefile(ofile);

    end else showmessage('No source files defined');{if apt file and input files}
    end;{if savedialog=true}

end;
{-----------------------------------------------------------------------}

procedure TForm2.Write_multiple_xgerbers;
var
z,
x,y :Integer;
xss,
inbuf        :AnsiString;
begin
    if ((ComboBox1.Text<>'')AND(listbox1.Items.count>=1))  then
    begin
       x:=0;
       While(x<listbox1.items.count) do
          begin
          AssignFile(ofile,listbox1.items[x]+'.xgerber');
          Rewrite(ofile);
          Write_Apts();
          Assignfile(ifile,listbox1.items[x]);
          RESET(ifile);
          writeln(ofile,'G04 data from ',listbox1.items[x],'*');
          inbuf:=listbox1.items[x];
          y:=length(inbuf);
          while ((inbuf[y]<>'\')AND(y>0)) do y:=y-1;
          xss:='';
          if(y>1) then y:=y+1;
          while (y<=length(inbuf)) do begin xss:=xss+ upcase(inbuf[y]); y:=y+1; end;
          writeln(ofile,'%IN',xss,'*%');
          While (Not EOF(ifile)) do
              begin
                 readln(ifile,inbuf);
                 z:=1;
                 while(z<length(inbuf)) do
                 begin
                   if ((inbuf[z]='M')AND(inbuf[z+1]='0')AND(inbuf[z+2]='2'))
                    then begin
                       inbuf[z]:=' ';
                       inbuf[z+1]:=' ';
                       inbuf[z+2]:=' ';
                       inbuf[z+3]:=' ';
                       end;
                 z:=z+1;
                 end;
                 if (inbuf[1]<>chr(8)) then writeln(ofile,inbuf);
              end;
          closefile(ifile);
          writeln(ofile,'M02*');
          closefile(ofile);
          x:=x+1;
          end;


    end else showmessage('No source files defined');{if apt file and input files}

end;
{-----------------------------------------------------------------------}

procedure TForm2.Button3Click(Sender: TObject);
begin
     if (RadioGroup3.itemindex=0) then Write_one_xgerber else
                                       Write_multiple_xgerbers;
     showmessage('Done!');
end;

{-----------------------------------------------------------------------}

procedure TForm2.FormCreate(Sender: TObject);
begin
   spinedit1.value:=Form1.f2v1;
   spinedit2.value:=Form1.f2v2;
   Radiogroup1.ItemIndex:=Form1.f2v3;
   Radiogroup2.itemIndex:=Form1.f2v4;

end;

{-----------------------------------------------------------------------}

end.
